//+------------------------------------------------------------------+
//|                                                   OtherChart.mq4 |
//|                      Copyright  2008, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "jax1000"
#property link      "jax1000@list.ru"
#property indicator_chart_window
#property indicator_buffers 8
//        ,       .
//..        ,   ,    . 
//,           ,    (EUR, USD, GBP, CHF, JPY, CAD, AUD, NZD),   . 
//        . 
//     ,   :    +(    -    ). 
// ,       ,   ,      . 
//        ,         ,    -    .
//http://www.onix-trade.net/forum/index.php?showtopic=107&view=findpost&p=383010

extern color color1=MediumBlue;
extern color color2=LimeGreen;
extern color color3=Crimson;
extern color color4=SaddleBrown;
extern color color5=Yellow;
extern color color6=DeepPink;
extern color color7=BlueViolet;
extern color color8=Turquoise;
extern bool all_idx_mode=true;//  -      ( true)     -        ( false).
extern int =8;//   
extern int 1=8;// ""   
extern int 2=24;// ""   
extern int MA_Method=0;//      .  -  .
extern int Price=0;//       .  - .
extern int =0;//     .
extern int =3;
   
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
double Buffer1[],Buffer2[],Buffer3[],Buffer4[],Buffer5[],Buffer6[],Buffer7[],Buffer8[];





//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {   
  //    ,   .
   string s=Symbol();
   string k=StringSubstr(Symbol(), 3, 3);//  
   string b=StringSubstr(Symbol(), 0, 3);//  
   string buffer1_name;
   string buffer2_name;
   if(all_idx_mode==false){buffer1_name=k;buffer2_name=b;}else{buffer1_name="EUR";buffer2_name="USD";}
   IndicatorDigits(Digits);
   SetIndexStyle(0,DRAW_LINE,0,,color1);
   SetIndexBuffer(0,Buffer1);
   SetIndexStyle(1,DRAW_LINE,0,,color2);
   SetIndexBuffer(1,Buffer2);
   SetIndexStyle(2,DRAW_LINE,0,,color3);
   SetIndexBuffer(2,Buffer3);
   SetIndexStyle(3,DRAW_LINE,0,,color4);
   SetIndexBuffer(3,Buffer4);
   SetIndexStyle(4,DRAW_LINE,0,,color5);
   SetIndexBuffer(4,Buffer5);
   SetIndexStyle(5,DRAW_LINE,0,,color6);
   SetIndexBuffer(5,Buffer6);
   SetIndexStyle(6,DRAW_LINE,0,,color7);
   SetIndexBuffer(6,Buffer7);
   SetIndexStyle(7,DRAW_LINE,0,,color8);
   SetIndexBuffer(7,Buffer8);
   SetIndexLabel(0,buffer1_name);
   SetIndexLabel(1,buffer2_name);
   SetIndexLabel(2,"GBP");
   SetIndexLabel(3,"CHF");
   SetIndexLabel(4,"JPY");
   SetIndexLabel(5,"CAD");
   SetIndexLabel(6,"AUD");
   SetIndexLabel(7,"NZD");
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()

  {
   int    i;
   int limit;
   int counted_bars=IndicatorCounted();
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
   for(i=0; i<limit; i++)
     {   
   datetime  = Time[i];
   //   
   int EUR = iBarShift("EURUSD", 0, );
   int GBP = iBarShift("GBPUSD", 0, );
   int CHF = iBarShift("USDCHF", 0, );
   int JPY = iBarShift("USDJPY", 0, );
   int CAD = iBarShift("USDCAD", 0, );
   int AUD = iBarShift("AUDUSD", 0, );
   int NZD = iBarShift("NZDUSD", 0, );
   //      .
   double usd1=MathPow(Ma("USDCHF",0,1,,MA_Method,Price,CHF)*Ma("USDJPY",0,1,,MA_Method,Price,JPY)*Ma("USDCAD",0,1,,MA_Method,Price,CAD)/Ma("EURUSD",0,1,,MA_Method,Price,EUR)/Ma("GBPUSD",0,1,,MA_Method,Price,GBP)/Ma("AUDUSD",0,1,,MA_Method,Price,AUD)/Ma("NZDUSD",0,1,,MA_Method,Price,NZD),1./8.);
   if (usd1==0) continue;
   double eur1=Ma("EURUSD",0,1,,MA_Method,Price,EUR)*usd1;
   double gbp1=Ma("GBPUSD",0,1,,MA_Method,Price,GBP)*usd1;
   double chf1=usd1/Ma("USDCHF",0,1,,MA_Method,Price,CHF);
   double idxjpy1=(Ma("USDJPY",0,1,,MA_Method,Price,JPY))/usd1;
   double cad1=usd1/Ma("USDCAD",0,1,,MA_Method,Price,CAD);
   double aud1=Ma("AUDUSD",0,1,,MA_Method,Price,AUD)*usd1;
   double nzd1=Ma("NZDUSD",0,1,,MA_Method,Price,NZD)*usd1;
   //      .
   double usd2=MathPow(Ma("USDCHF",0,2,,MA_Method,Price,CHF)*Ma("USDJPY",0,2,,MA_Method,Price,JPY)*Ma("USDCAD",0,2,,MA_Method,Price,CAD)/Ma("EURUSD",0,2,,MA_Method,Price,EUR)/Ma("GBPUSD",0,2,,MA_Method,Price,GBP)/Ma("AUDUSD",0,2,,MA_Method,Price,AUD)/Ma("NZDUSD",0,2,,MA_Method,Price,NZD),1./8.);
   if (usd2==0) continue;
   double eur2=Ma("EURUSD",0,2,,MA_Method,Price,EUR)*usd2;
   double gbp2=Ma("GBPUSD",0,2,,MA_Method,Price,GBP)*usd2;
   double chf2=usd2/Ma("USDCHF",0,2,,MA_Method,Price,CHF);
   double idxjpy2=(Ma("USDJPY",0,2,,MA_Method,Price,JPY))/usd2;
   double cad2=usd2/Ma("USDCAD",0,2,,MA_Method,Price,CAD);
   double aud2=Ma("AUDUSD",0,2,,MA_Method,Price,AUD)*usd2;
   double nzd2=Ma("NZDUSD",0,2,,MA_Method,Price,NZD)*usd2;
   //  ""   "",    . (  )
   double usdp=usd1-usd2;
   double eurp=eur1-eur2;
   double gbpp=gbp1-gbp2;
   double chfp=chf1-chf2;
   double idxjpyp=idxjpy1-idxjpy2;
   double cadp=cad1-cad2;
   double audp=aud1-aud2;
   double nzdp=nzd1-nzd2;
   string s=Symbol();
   string k=StringSubstr(Symbol(), 3, 3);//  
   string b=StringSubstr(Symbol(), 0, 3);//  
   // ,            .
   double ch1, ch2;
   if(b=="USD"){ch1=usdp;}    
   if(b=="EUR"){ch1=eurp;}    if(k=="USD"){ch2=usdp;}
   if(b=="GBP"){ch1=gbpp;}    if(k=="GBP"){ch2=gbpp;}
   if(b=="CHF"){ch1=chfp;}    if(k=="CHF"){ch2=chfp;}
                              if(k=="JPY"){ch2=idxjpyp;}
   if(b=="CAD"){ch1=cadp;}    if(k=="CAD"){ch2=cadp;}
   if(b=="NZD"){ch1=nzdp;}    if(k=="AUD"){ch2=audp;}
   if(b=="AUD"){ch1=audp;}    if(k=="NZD"){ch2=nzdp;}


   // ,    ;    ,   ;    ,        .
   if(all_idx_mode){//      
      if(k=="JPY")// k  "JPY" 
      {
      Buffer1[i]=Ma(s,0,,,MA_Method,Price,i)+eurp*100;
      Buffer2[i]=Ma(s,0,,,MA_Method,Price,i)+usdp*100;
      Buffer3[i]=Ma(s,0,,,MA_Method,Price,i)+gbpp*100;
      Buffer4[i]=Ma(s,0,,,MA_Method,Price,i)+chfp*100;
      Buffer5[i]=Ma(s,0,,,MA_Method,Price,i)-idxjpyp;
      Buffer6[i]=Ma(s,0,,,MA_Method,Price,i)+cadp*100;
      Buffer7[i]=Ma(s,0,,,MA_Method,Price,i)+audp*100;
      Buffer8[i]=Ma(s,0,,,MA_Method,Price,i)+nzdp*100;

      }
      else
      {
      Buffer1[i]=Ma(s,0,,,MA_Method,Price,i)+eurp;
      Buffer2[i]=Ma(s,0,,,MA_Method,Price,i)+usdp;
      Buffer3[i]=Ma(s,0,,,MA_Method,Price,i)+gbpp;
      Buffer4[i]=Ma(s,0,,,MA_Method,Price,i)+chfp;
      Buffer5[i]=Ma(s,0,,,MA_Method,Price,i)-idxjpyp/100;
      Buffer6[i]=Ma(s,0,,,MA_Method,Price,i)+cadp;
      Buffer7[i]=Ma(s,0,,,MA_Method,Price,i)+audp;
      Buffer8[i]=Ma(s,0,,,MA_Method,Price,i)+nzdp;
      }
      
 }
 else   //   -       
 {if(k=="JPY")
      {
      Buffer1[i]=Ma(s,0,,,MA_Method,Price,i)+ch1*100;
      Buffer2[i]=Ma(s,0,,,MA_Method,Price,i)-ch2;
      }
      else
      {
      Buffer1[i]=Ma(s,0,,,MA_Method,Price,i)+ch1;
      Buffer2[i]=Ma(s,0,,,MA_Method,Price,i)+ch2;
      }}
 

   
   }
//----

   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//   
double Ma(string valuta, int frame, int t, int t, int tMA_Method, int tPrice, int z)
  {
   double res1=0;
   res1=iMA(valuta,frame,t,t,tMA_Method,tPrice,z);
   return(res1);
  } 

